<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfMemberPaymentOption ArrayType
 * @subpackage Arrays
 */
class ArrayOfMemberPaymentOption extends AbstractStructArrayBase
{
    /**
     * The MemberPaymentOption
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\MemberPaymentOption[]
     */
    public $MemberPaymentOption;
    /**
     * Constructor method for ArrayOfMemberPaymentOption
     * @uses ArrayOfMemberPaymentOption::setMemberPaymentOption()
     * @param \StructType\MemberPaymentOption[] $memberPaymentOption
     */
    public function __construct(array $memberPaymentOption = array())
    {
        $this
            ->setMemberPaymentOption($memberPaymentOption);
    }
    /**
     * Get MemberPaymentOption value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\MemberPaymentOption[]|null
     */
    public function getMemberPaymentOption()
    {
        return isset($this->MemberPaymentOption) ? $this->MemberPaymentOption : null;
    }
    /**
     * This method is responsible for validating the values passed to the setMemberPaymentOption method
     * This method is willingly generated in order to preserve the one-line inline validation within the setMemberPaymentOption method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateMemberPaymentOptionForArrayConstraintsFromSetMemberPaymentOption(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfMemberPaymentOptionMemberPaymentOptionItem) {
            // validation for constraint: itemType
            if (!$arrayOfMemberPaymentOptionMemberPaymentOptionItem instanceof \StructType\MemberPaymentOption) {
                $invalidValues[] = is_object($arrayOfMemberPaymentOptionMemberPaymentOptionItem) ? get_class($arrayOfMemberPaymentOptionMemberPaymentOptionItem) : sprintf('%s(%s)', gettype($arrayOfMemberPaymentOptionMemberPaymentOptionItem), var_export($arrayOfMemberPaymentOptionMemberPaymentOptionItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The MemberPaymentOption property can only contain items of type \StructType\MemberPaymentOption, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set MemberPaymentOption value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\MemberPaymentOption[] $memberPaymentOption
     * @return \ArrayType\ArrayOfMemberPaymentOption
     */
    public function setMemberPaymentOption(array $memberPaymentOption = array())
    {
        // validation for constraint: array
        if ('' !== ($memberPaymentOptionArrayErrorMessage = self::validateMemberPaymentOptionForArrayConstraintsFromSetMemberPaymentOption($memberPaymentOption))) {
            throw new \InvalidArgumentException($memberPaymentOptionArrayErrorMessage, __LINE__);
        }
        if (is_null($memberPaymentOption) || (is_array($memberPaymentOption) && empty($memberPaymentOption))) {
            unset($this->MemberPaymentOption);
        } else {
            $this->MemberPaymentOption = $memberPaymentOption;
        }
        return $this;
    }
    /**
     * Add item to MemberPaymentOption value
     * @throws \InvalidArgumentException
     * @param \StructType\MemberPaymentOption $item
     * @return \ArrayType\ArrayOfMemberPaymentOption
     */
    public function addToMemberPaymentOption(\StructType\MemberPaymentOption $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\MemberPaymentOption) {
            throw new \InvalidArgumentException(sprintf('The MemberPaymentOption property can only contain items of type \StructType\MemberPaymentOption, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->MemberPaymentOption[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\MemberPaymentOption|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\MemberPaymentOption|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\MemberPaymentOption|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\MemberPaymentOption|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\MemberPaymentOption|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string MemberPaymentOption
     */
    public function getAttributeName()
    {
        return 'MemberPaymentOption';
    }
}
