<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSetActivateDateShopItem ArrayType
 * @subpackage Arrays
 */
class ArrayOfSetActivateDateShopItem extends AbstractStructArrayBase
{
    /**
     * The SetActivateDateShopItem
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\SetActivateDateShopItem[]
     */
    public $SetActivateDateShopItem;
    /**
     * Constructor method for ArrayOfSetActivateDateShopItem
     * @uses ArrayOfSetActivateDateShopItem::setSetActivateDateShopItem()
     * @param \StructType\SetActivateDateShopItem[] $setActivateDateShopItem
     */
    public function __construct(array $setActivateDateShopItem = array())
    {
        $this
            ->setSetActivateDateShopItem($setActivateDateShopItem);
    }
    /**
     * Get SetActivateDateShopItem value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\SetActivateDateShopItem[]|null
     */
    public function getSetActivateDateShopItem()
    {
        return isset($this->SetActivateDateShopItem) ? $this->SetActivateDateShopItem : null;
    }
    /**
     * This method is responsible for validating the values passed to the setSetActivateDateShopItem method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSetActivateDateShopItem method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSetActivateDateShopItemForArrayConstraintsFromSetSetActivateDateShopItem(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfSetActivateDateShopItemSetActivateDateShopItemItem) {
            // validation for constraint: itemType
            if (!$arrayOfSetActivateDateShopItemSetActivateDateShopItemItem instanceof \StructType\SetActivateDateShopItem) {
                $invalidValues[] = is_object($arrayOfSetActivateDateShopItemSetActivateDateShopItemItem) ? get_class($arrayOfSetActivateDateShopItemSetActivateDateShopItemItem) : sprintf('%s(%s)', gettype($arrayOfSetActivateDateShopItemSetActivateDateShopItemItem), var_export($arrayOfSetActivateDateShopItemSetActivateDateShopItemItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SetActivateDateShopItem property can only contain items of type \StructType\SetActivateDateShopItem, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SetActivateDateShopItem value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\SetActivateDateShopItem[] $setActivateDateShopItem
     * @return \ArrayType\ArrayOfSetActivateDateShopItem
     */
    public function setSetActivateDateShopItem(array $setActivateDateShopItem = array())
    {
        // validation for constraint: array
        if ('' !== ($setActivateDateShopItemArrayErrorMessage = self::validateSetActivateDateShopItemForArrayConstraintsFromSetSetActivateDateShopItem($setActivateDateShopItem))) {
            throw new \InvalidArgumentException($setActivateDateShopItemArrayErrorMessage, __LINE__);
        }
        if (is_null($setActivateDateShopItem) || (is_array($setActivateDateShopItem) && empty($setActivateDateShopItem))) {
            unset($this->SetActivateDateShopItem);
        } else {
            $this->SetActivateDateShopItem = $setActivateDateShopItem;
        }
        return $this;
    }
    /**
     * Add item to SetActivateDateShopItem value
     * @throws \InvalidArgumentException
     * @param \StructType\SetActivateDateShopItem $item
     * @return \ArrayType\ArrayOfSetActivateDateShopItem
     */
    public function addToSetActivateDateShopItem(\StructType\SetActivateDateShopItem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SetActivateDateShopItem) {
            throw new \InvalidArgumentException(sprintf('The SetActivateDateShopItem property can only contain items of type \StructType\SetActivateDateShopItem, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SetActivateDateShopItem[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\SetActivateDateShopItem|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\SetActivateDateShopItem|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\SetActivateDateShopItem|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\SetActivateDateShopItem|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\SetActivateDateShopItem|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SetActivateDateShopItem
     */
    public function getAttributeName()
    {
        return 'SetActivateDateShopItem';
    }
}
