<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSetPriceOnShopItemsError ArrayType
 * @subpackage Arrays
 */
class ArrayOfSetPriceOnShopItemsError extends AbstractStructArrayBase
{
    /**
     * The SetPriceOnShopItemsError
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\SetPriceOnShopItemsError[]
     */
    public $SetPriceOnShopItemsError;
    /**
     * Constructor method for ArrayOfSetPriceOnShopItemsError
     * @uses ArrayOfSetPriceOnShopItemsError::setSetPriceOnShopItemsError()
     * @param \StructType\SetPriceOnShopItemsError[] $setPriceOnShopItemsError
     */
    public function __construct(array $setPriceOnShopItemsError = array())
    {
        $this
            ->setSetPriceOnShopItemsError($setPriceOnShopItemsError);
    }
    /**
     * Get SetPriceOnShopItemsError value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\SetPriceOnShopItemsError[]|null
     */
    public function getSetPriceOnShopItemsError()
    {
        return isset($this->SetPriceOnShopItemsError) ? $this->SetPriceOnShopItemsError : null;
    }
    /**
     * This method is responsible for validating the values passed to the setSetPriceOnShopItemsError method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSetPriceOnShopItemsError method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSetPriceOnShopItemsErrorForArrayConstraintsFromSetSetPriceOnShopItemsError(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfSetPriceOnShopItemsErrorSetPriceOnShopItemsErrorItem) {
            // validation for constraint: itemType
            if (!$arrayOfSetPriceOnShopItemsErrorSetPriceOnShopItemsErrorItem instanceof \StructType\SetPriceOnShopItemsError) {
                $invalidValues[] = is_object($arrayOfSetPriceOnShopItemsErrorSetPriceOnShopItemsErrorItem) ? get_class($arrayOfSetPriceOnShopItemsErrorSetPriceOnShopItemsErrorItem) : sprintf('%s(%s)', gettype($arrayOfSetPriceOnShopItemsErrorSetPriceOnShopItemsErrorItem), var_export($arrayOfSetPriceOnShopItemsErrorSetPriceOnShopItemsErrorItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SetPriceOnShopItemsError property can only contain items of type \StructType\SetPriceOnShopItemsError, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SetPriceOnShopItemsError value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\SetPriceOnShopItemsError[] $setPriceOnShopItemsError
     * @return \ArrayType\ArrayOfSetPriceOnShopItemsError
     */
    public function setSetPriceOnShopItemsError(array $setPriceOnShopItemsError = array())
    {
        // validation for constraint: array
        if ('' !== ($setPriceOnShopItemsErrorArrayErrorMessage = self::validateSetPriceOnShopItemsErrorForArrayConstraintsFromSetSetPriceOnShopItemsError($setPriceOnShopItemsError))) {
            throw new \InvalidArgumentException($setPriceOnShopItemsErrorArrayErrorMessage, __LINE__);
        }
        if (is_null($setPriceOnShopItemsError) || (is_array($setPriceOnShopItemsError) && empty($setPriceOnShopItemsError))) {
            unset($this->SetPriceOnShopItemsError);
        } else {
            $this->SetPriceOnShopItemsError = $setPriceOnShopItemsError;
        }
        return $this;
    }
    /**
     * Add item to SetPriceOnShopItemsError value
     * @throws \InvalidArgumentException
     * @param \StructType\SetPriceOnShopItemsError $item
     * @return \ArrayType\ArrayOfSetPriceOnShopItemsError
     */
    public function addToSetPriceOnShopItemsError(\StructType\SetPriceOnShopItemsError $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SetPriceOnShopItemsError) {
            throw new \InvalidArgumentException(sprintf('The SetPriceOnShopItemsError property can only contain items of type \StructType\SetPriceOnShopItemsError, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SetPriceOnShopItemsError[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\SetPriceOnShopItemsError|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\SetPriceOnShopItemsError|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\SetPriceOnShopItemsError|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\SetPriceOnShopItemsError|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\SetPriceOnShopItemsError|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SetPriceOnShopItemsError
     */
    public function getAttributeName()
    {
        return 'SetPriceOnShopItemsError';
    }
}
