<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSetPriceShopItem ArrayType
 * @subpackage Arrays
 */
class ArrayOfSetPriceShopItem extends AbstractStructArrayBase
{
    /**
     * The SetPriceShopItem
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\SetPriceShopItem[]
     */
    public $SetPriceShopItem;
    /**
     * Constructor method for ArrayOfSetPriceShopItem
     * @uses ArrayOfSetPriceShopItem::setSetPriceShopItem()
     * @param \StructType\SetPriceShopItem[] $setPriceShopItem
     */
    public function __construct(array $setPriceShopItem = array())
    {
        $this
            ->setSetPriceShopItem($setPriceShopItem);
    }
    /**
     * Get SetPriceShopItem value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\SetPriceShopItem[]|null
     */
    public function getSetPriceShopItem()
    {
        return isset($this->SetPriceShopItem) ? $this->SetPriceShopItem : null;
    }
    /**
     * This method is responsible for validating the values passed to the setSetPriceShopItem method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSetPriceShopItem method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSetPriceShopItemForArrayConstraintsFromSetSetPriceShopItem(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfSetPriceShopItemSetPriceShopItemItem) {
            // validation for constraint: itemType
            if (!$arrayOfSetPriceShopItemSetPriceShopItemItem instanceof \StructType\SetPriceShopItem) {
                $invalidValues[] = is_object($arrayOfSetPriceShopItemSetPriceShopItemItem) ? get_class($arrayOfSetPriceShopItemSetPriceShopItemItem) : sprintf('%s(%s)', gettype($arrayOfSetPriceShopItemSetPriceShopItemItem), var_export($arrayOfSetPriceShopItemSetPriceShopItemItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SetPriceShopItem property can only contain items of type \StructType\SetPriceShopItem, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SetPriceShopItem value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\SetPriceShopItem[] $setPriceShopItem
     * @return \ArrayType\ArrayOfSetPriceShopItem
     */
    public function setSetPriceShopItem(array $setPriceShopItem = array())
    {
        // validation for constraint: array
        if ('' !== ($setPriceShopItemArrayErrorMessage = self::validateSetPriceShopItemForArrayConstraintsFromSetSetPriceShopItem($setPriceShopItem))) {
            throw new \InvalidArgumentException($setPriceShopItemArrayErrorMessage, __LINE__);
        }
        if (is_null($setPriceShopItem) || (is_array($setPriceShopItem) && empty($setPriceShopItem))) {
            unset($this->SetPriceShopItem);
        } else {
            $this->SetPriceShopItem = $setPriceShopItem;
        }
        return $this;
    }
    /**
     * Add item to SetPriceShopItem value
     * @throws \InvalidArgumentException
     * @param \StructType\SetPriceShopItem $item
     * @return \ArrayType\ArrayOfSetPriceShopItem
     */
    public function addToSetPriceShopItem(\StructType\SetPriceShopItem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SetPriceShopItem) {
            throw new \InvalidArgumentException(sprintf('The SetPriceShopItem property can only contain items of type \StructType\SetPriceShopItem, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SetPriceShopItem[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\SetPriceShopItem|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\SetPriceShopItem|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\SetPriceShopItem|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\SetPriceShopItem|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\SetPriceShopItem|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SetPriceShopItem
     */
    public function getAttributeName()
    {
        return 'SetPriceShopItem';
    }
}
