<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSetQuantityOnShopItemError ArrayType
 * @subpackage Arrays
 */
class ArrayOfSetQuantityOnShopItemError extends AbstractStructArrayBase
{
    /**
     * The SetQuantityOnShopItemError
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\SetQuantityOnShopItemError[]
     */
    public $SetQuantityOnShopItemError;
    /**
     * Constructor method for ArrayOfSetQuantityOnShopItemError
     * @uses ArrayOfSetQuantityOnShopItemError::setSetQuantityOnShopItemError()
     * @param \StructType\SetQuantityOnShopItemError[] $setQuantityOnShopItemError
     */
    public function __construct(array $setQuantityOnShopItemError = array())
    {
        $this
            ->setSetQuantityOnShopItemError($setQuantityOnShopItemError);
    }
    /**
     * Get SetQuantityOnShopItemError value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\SetQuantityOnShopItemError[]|null
     */
    public function getSetQuantityOnShopItemError()
    {
        return isset($this->SetQuantityOnShopItemError) ? $this->SetQuantityOnShopItemError : null;
    }
    /**
     * This method is responsible for validating the values passed to the setSetQuantityOnShopItemError method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSetQuantityOnShopItemError method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSetQuantityOnShopItemErrorForArrayConstraintsFromSetSetQuantityOnShopItemError(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfSetQuantityOnShopItemErrorSetQuantityOnShopItemErrorItem) {
            // validation for constraint: itemType
            if (!$arrayOfSetQuantityOnShopItemErrorSetQuantityOnShopItemErrorItem instanceof \StructType\SetQuantityOnShopItemError) {
                $invalidValues[] = is_object($arrayOfSetQuantityOnShopItemErrorSetQuantityOnShopItemErrorItem) ? get_class($arrayOfSetQuantityOnShopItemErrorSetQuantityOnShopItemErrorItem) : sprintf('%s(%s)', gettype($arrayOfSetQuantityOnShopItemErrorSetQuantityOnShopItemErrorItem), var_export($arrayOfSetQuantityOnShopItemErrorSetQuantityOnShopItemErrorItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SetQuantityOnShopItemError property can only contain items of type \StructType\SetQuantityOnShopItemError, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SetQuantityOnShopItemError value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\SetQuantityOnShopItemError[] $setQuantityOnShopItemError
     * @return \ArrayType\ArrayOfSetQuantityOnShopItemError
     */
    public function setSetQuantityOnShopItemError(array $setQuantityOnShopItemError = array())
    {
        // validation for constraint: array
        if ('' !== ($setQuantityOnShopItemErrorArrayErrorMessage = self::validateSetQuantityOnShopItemErrorForArrayConstraintsFromSetSetQuantityOnShopItemError($setQuantityOnShopItemError))) {
            throw new \InvalidArgumentException($setQuantityOnShopItemErrorArrayErrorMessage, __LINE__);
        }
        if (is_null($setQuantityOnShopItemError) || (is_array($setQuantityOnShopItemError) && empty($setQuantityOnShopItemError))) {
            unset($this->SetQuantityOnShopItemError);
        } else {
            $this->SetQuantityOnShopItemError = $setQuantityOnShopItemError;
        }
        return $this;
    }
    /**
     * Add item to SetQuantityOnShopItemError value
     * @throws \InvalidArgumentException
     * @param \StructType\SetQuantityOnShopItemError $item
     * @return \ArrayType\ArrayOfSetQuantityOnShopItemError
     */
    public function addToSetQuantityOnShopItemError(\StructType\SetQuantityOnShopItemError $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SetQuantityOnShopItemError) {
            throw new \InvalidArgumentException(sprintf('The SetQuantityOnShopItemError property can only contain items of type \StructType\SetQuantityOnShopItemError, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SetQuantityOnShopItemError[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\SetQuantityOnShopItemError|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\SetQuantityOnShopItemError|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\SetQuantityOnShopItemError|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\SetQuantityOnShopItemError|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\SetQuantityOnShopItemError|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SetQuantityOnShopItemError
     */
    public function getAttributeName()
    {
        return 'SetQuantityOnShopItemError';
    }
}
