<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSetQuantityShopItem ArrayType
 * @subpackage Arrays
 */
class ArrayOfSetQuantityShopItem extends AbstractStructArrayBase
{
    /**
     * The SetQuantityShopItem
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\SetQuantityShopItem[]
     */
    public $SetQuantityShopItem;
    /**
     * Constructor method for ArrayOfSetQuantityShopItem
     * @uses ArrayOfSetQuantityShopItem::setSetQuantityShopItem()
     * @param \StructType\SetQuantityShopItem[] $setQuantityShopItem
     */
    public function __construct(array $setQuantityShopItem = array())
    {
        $this
            ->setSetQuantityShopItem($setQuantityShopItem);
    }
    /**
     * Get SetQuantityShopItem value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\SetQuantityShopItem[]|null
     */
    public function getSetQuantityShopItem()
    {
        return isset($this->SetQuantityShopItem) ? $this->SetQuantityShopItem : null;
    }
    /**
     * This method is responsible for validating the values passed to the setSetQuantityShopItem method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSetQuantityShopItem method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSetQuantityShopItemForArrayConstraintsFromSetSetQuantityShopItem(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfSetQuantityShopItemSetQuantityShopItemItem) {
            // validation for constraint: itemType
            if (!$arrayOfSetQuantityShopItemSetQuantityShopItemItem instanceof \StructType\SetQuantityShopItem) {
                $invalidValues[] = is_object($arrayOfSetQuantityShopItemSetQuantityShopItemItem) ? get_class($arrayOfSetQuantityShopItemSetQuantityShopItemItem) : sprintf('%s(%s)', gettype($arrayOfSetQuantityShopItemSetQuantityShopItemItem), var_export($arrayOfSetQuantityShopItemSetQuantityShopItemItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SetQuantityShopItem property can only contain items of type \StructType\SetQuantityShopItem, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SetQuantityShopItem value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\SetQuantityShopItem[] $setQuantityShopItem
     * @return \ArrayType\ArrayOfSetQuantityShopItem
     */
    public function setSetQuantityShopItem(array $setQuantityShopItem = array())
    {
        // validation for constraint: array
        if ('' !== ($setQuantityShopItemArrayErrorMessage = self::validateSetQuantityShopItemForArrayConstraintsFromSetSetQuantityShopItem($setQuantityShopItem))) {
            throw new \InvalidArgumentException($setQuantityShopItemArrayErrorMessage, __LINE__);
        }
        if (is_null($setQuantityShopItem) || (is_array($setQuantityShopItem) && empty($setQuantityShopItem))) {
            unset($this->SetQuantityShopItem);
        } else {
            $this->SetQuantityShopItem = $setQuantityShopItem;
        }
        return $this;
    }
    /**
     * Add item to SetQuantityShopItem value
     * @throws \InvalidArgumentException
     * @param \StructType\SetQuantityShopItem $item
     * @return \ArrayType\ArrayOfSetQuantityShopItem
     */
    public function addToSetQuantityShopItem(\StructType\SetQuantityShopItem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SetQuantityShopItem) {
            throw new \InvalidArgumentException(sprintf('The SetQuantityShopItem property can only contain items of type \StructType\SetQuantityShopItem, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SetQuantityShopItem[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\SetQuantityShopItem|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\SetQuantityShopItem|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\SetQuantityShopItem|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\SetQuantityShopItem|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\SetQuantityShopItem|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SetQuantityShopItem
     */
    public function getAttributeName()
    {
        return 'SetQuantityShopItem';
    }
}
