<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTermAttributeValue ArrayType
 * @subpackage Arrays
 */
class ArrayOfTermAttributeValue extends AbstractStructArrayBase
{
    /**
     * The TermAttributeValue
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TermAttributeValue[]
     */
    public $TermAttributeValue;
    /**
     * Constructor method for ArrayOfTermAttributeValue
     * @uses ArrayOfTermAttributeValue::setTermAttributeValue()
     * @param \StructType\TermAttributeValue[] $termAttributeValue
     */
    public function __construct(array $termAttributeValue = array())
    {
        $this
            ->setTermAttributeValue($termAttributeValue);
    }
    /**
     * Get TermAttributeValue value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TermAttributeValue[]|null
     */
    public function getTermAttributeValue()
    {
        return isset($this->TermAttributeValue) ? $this->TermAttributeValue : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTermAttributeValue method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTermAttributeValue method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTermAttributeValueForArrayConstraintsFromSetTermAttributeValue(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTermAttributeValueTermAttributeValueItem) {
            // validation for constraint: itemType
            if (!$arrayOfTermAttributeValueTermAttributeValueItem instanceof \StructType\TermAttributeValue) {
                $invalidValues[] = is_object($arrayOfTermAttributeValueTermAttributeValueItem) ? get_class($arrayOfTermAttributeValueTermAttributeValueItem) : sprintf('%s(%s)', gettype($arrayOfTermAttributeValueTermAttributeValueItem), var_export($arrayOfTermAttributeValueTermAttributeValueItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TermAttributeValue property can only contain items of type \StructType\TermAttributeValue, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TermAttributeValue value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TermAttributeValue[] $termAttributeValue
     * @return \ArrayType\ArrayOfTermAttributeValue
     */
    public function setTermAttributeValue(array $termAttributeValue = array())
    {
        // validation for constraint: array
        if ('' !== ($termAttributeValueArrayErrorMessage = self::validateTermAttributeValueForArrayConstraintsFromSetTermAttributeValue($termAttributeValue))) {
            throw new \InvalidArgumentException($termAttributeValueArrayErrorMessage, __LINE__);
        }
        if (is_null($termAttributeValue) || (is_array($termAttributeValue) && empty($termAttributeValue))) {
            unset($this->TermAttributeValue);
        } else {
            $this->TermAttributeValue = $termAttributeValue;
        }
        return $this;
    }
    /**
     * Add item to TermAttributeValue value
     * @throws \InvalidArgumentException
     * @param \StructType\TermAttributeValue $item
     * @return \ArrayType\ArrayOfTermAttributeValue
     */
    public function addToTermAttributeValue(\StructType\TermAttributeValue $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TermAttributeValue) {
            throw new \InvalidArgumentException(sprintf('The TermAttributeValue property can only contain items of type \StructType\TermAttributeValue, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TermAttributeValue[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TermAttributeValue|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TermAttributeValue|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TermAttributeValue|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TermAttributeValue|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TermAttributeValue|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TermAttributeValue
     */
    public function getAttributeName()
    {
        return 'TermAttributeValue';
    }
}
