<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'GetItem' => '\\StructType\\GetItem',
            'GetItemResponse' => '\\StructType\\GetItemResponse',
            'Item' => '\\StructType\\Item',
            'ItemShipping' => '\\StructType\\ItemShipping',
            'ArrayOfInt' => '\\ArrayType\\ArrayOfInt',
            'ArrayOfString' => '\\ArrayType\\ArrayOfString',
            'User' => '\\StructType\\User',
            'ItemStatus' => '\\StructType\\ItemStatus',
            'AttributeValues' => '\\StructType\\AttributeValues',
            'ArrayOfTermAttributeValue' => '\\ArrayType\\ArrayOfTermAttributeValue',
            'TermAttributeValue' => '\\StructType\\TermAttributeValue',
            'ArrayOfNumberAttributeValue' => '\\ArrayType\\ArrayOfNumberAttributeValue',
            'NumberAttributeValue' => '\\StructType\\NumberAttributeValue',
            'ArrayOfDecimal' => '\\ArrayType\\ArrayOfDecimal',
            'AuthenticationHeader' => '\\StructType\\AuthenticationHeader',
            'AuthorizationHeader' => '\\StructType\\AuthorizationHeader',
            'ConfigurationHeader' => '\\StructType\\ConfigurationHeader',
            'GetSellerItems' => '\\StructType\\GetSellerItems',
            'GetSellerItemsResponse' => '\\StructType\\GetSellerItemsResponse',
            'ArrayOfItem' => '\\ArrayType\\ArrayOfItem',
            'GetSellerTransactions' => '\\StructType\\GetSellerTransactions',
            'GetSellerTransactionsRequest' => '\\StructType\\GetSellerTransactionsRequest',
            'GetSellerTransactionsResponse' => '\\StructType\\GetSellerTransactionsResponse',
            'ArrayOfTransaction' => '\\ArrayType\\ArrayOfTransaction',
            'Transaction' => '\\StructType\\Transaction',
            'TransactionItem' => '\\StructType\\TransactionItem',
            'AddItem' => '\\StructType\\AddItem',
            'ItemRequest' => '\\StructType\\ItemRequest',
            'ArrayOfItemShipping' => '\\ArrayType\\ArrayOfItemShipping',
            'ItemAttributeValues' => '\\StructType\\ItemAttributeValues',
            'ArrayOfTermValues' => '\\ArrayType\\ArrayOfTermValues',
            'TermValues' => '\\StructType\\TermValues',
            'ArrayOfNumberValues' => '\\ArrayType\\ArrayOfNumberValues',
            'NumberValues' => '\\StructType\\NumberValues',
            'AddItemResponse' => '\\StructType\\AddItemResponse',
            'QueuedRequestResponse' => '\\StructType\\QueuedRequestResponse',
            'AddItemXml' => '\\StructType\\AddItemXml',
            'AddItemXmlResponse' => '\\StructType\\AddItemXmlResponse',
            'AddItemImage' => '\\StructType\\AddItemImage',
            'AddItemImageResponse' => '\\StructType\\AddItemImageResponse',
            'AddItemCampaignCode' => '\\StructType\\AddItemCampaignCode',
            'AddItemCampaignCodeResponse' => '\\StructType\\AddItemCampaignCodeResponse',
            'ValidateCampaignCode' => '\\StructType\\ValidateCampaignCode',
            'ValidateCampaignCodeResponse' => '\\StructType\\ValidateCampaignCodeResponse',
            'ValidateCampaignCodeResult' => '\\StructType\\ValidateCampaignCodeResult',
            'AddItemCommit' => '\\StructType\\AddItemCommit',
            'AddItemCommitResponse' => '\\StructType\\AddItemCommitResponse',
            'LeaveFeedback' => '\\StructType\\LeaveFeedback',
            'LeaveFeedbackResponse' => '\\StructType\\LeaveFeedbackResponse',
            'EndItem' => '\\StructType\\EndItem',
            'EndItemResponse' => '\\StructType\\EndItemResponse',
            'AddShopItem' => '\\StructType\\AddShopItem',
            'ShopItemData' => '\\StructType\\ShopItemData',
            'ArrayOfItemImageData' => '\\ArrayType\\ArrayOfItemImageData',
            'ItemImageData' => '\\StructType\\ItemImageData',
            'AddShopItemResponse' => '\\StructType\\AddShopItemResponse',
            'AddShopItemVariant' => '\\StructType\\AddShopItemVariant',
            'ShopItemVariantData' => '\\StructType\\ShopItemVariantData',
            'VariantData' => '\\StructType\\VariantData',
            'ArrayOfVariantAttribute' => '\\ArrayType\\ArrayOfVariantAttribute',
            'VariantAttribute' => '\\StructType\\VariantAttribute',
            'AddShopItemVariantResponse' => '\\StructType\\AddShopItemVariantResponse',
            'UpdateShopItem' => '\\StructType\\UpdateShopItem',
            'ShopItemUpdateData' => '\\StructType\\ShopItemUpdateData',
            'UpdateShopItemResponse' => '\\StructType\\UpdateShopItemResponse',
            'UpdateShopItemVariant' => '\\StructType\\UpdateShopItemVariant',
            'ShopItemVariantUpdateData' => '\\StructType\\ShopItemVariantUpdateData',
            'UpdateShopItemVariantResponse' => '\\StructType\\UpdateShopItemVariantResponse',
            'GetRequestResults' => '\\StructType\\GetRequestResults',
            'GetRequestResultsResponse' => '\\StructType\\GetRequestResultsResponse',
            'ArrayOfRequestResult' => '\\ArrayType\\ArrayOfRequestResult',
            'RequestResult' => '\\StructType\\RequestResult',
            'RemoveShopItem' => '\\StructType\\RemoveShopItem',
            'RemoveShopItemResponse' => '\\StructType\\RemoveShopItemResponse',
            'SetShopSettings' => '\\StructType\\SetShopSettings',
            'ShopSettingsData' => '\\StructType\\ShopSettingsData',
            'ShopLogoData' => '\\StructType\\ShopLogoData',
            'SetShopSettingsResponse' => '\\StructType\\SetShopSettingsResponse',
            'GetShopSettings' => '\\StructType\\GetShopSettings',
            'GetShopSettingsResponse' => '\\StructType\\GetShopSettingsResponse',
            'UpdateTransactionStatus' => '\\StructType\\UpdateTransactionStatus',
            'TransactionStatusUpdateData' => '\\StructType\\TransactionStatusUpdateData',
            'UpdateTransactionStatusResponse' => '\\StructType\\UpdateTransactionStatusResponse',
            'GetUpdatedSellerItems' => '\\StructType\\GetUpdatedSellerItems',
            'GetUpdatedSellerItemsRequest' => '\\StructType\\GetUpdatedSellerItemsRequest',
            'GetUpdatedSellerItemsResponse' => '\\StructType\\GetUpdatedSellerItemsResponse',
            'ArrayOfUpdatedItemInfo' => '\\ArrayType\\ArrayOfUpdatedItemInfo',
            'UpdatedItemInfo' => '\\StructType\\UpdatedItemInfo',
            'GetUserInfo' => '\\StructType\\GetUserInfo',
            'GetUserInfoResponse' => '\\StructType\\GetUserInfoResponse',
            'SetPriceOnShopItems' => '\\StructType\\SetPriceOnShopItems',
            'SetPriceOnShopItemsRequest' => '\\StructType\\SetPriceOnShopItemsRequest',
            'ArrayOfSetPriceShopItem' => '\\ArrayType\\ArrayOfSetPriceShopItem',
            'SetPriceShopItem' => '\\StructType\\SetPriceShopItem',
            'SetPriceOnShopItemsResponse' => '\\StructType\\SetPriceOnShopItemsResponse',
            'SetPriceOnShopItemsResult' => '\\StructType\\SetPriceOnShopItemsResult',
            'ArrayOfQueuedRequestResponse' => '\\ArrayType\\ArrayOfQueuedRequestResponse',
            'ArrayOfSetPriceOnShopItemsError' => '\\ArrayType\\ArrayOfSetPriceOnShopItemsError',
            'SetPriceOnShopItemsError' => '\\StructType\\SetPriceOnShopItemsError',
            'SetPricesOnNonShopItems' => '\\StructType\\SetPricesOnNonShopItems',
            'SetPricesOnNonShopItemRequest' => '\\StructType\\SetPricesOnNonShopItemRequest',
            'SetPricesNonShopItem' => '\\StructType\\SetPricesNonShopItem',
            'ReservedPrice' => '\\StructType\\ReservedPrice',
            'BinPrice' => '\\StructType\\BinPrice',
            'SetPricesOnNonShopItemsResponse' => '\\StructType\\SetPricesOnNonShopItemsResponse',
            'SetPricesOnNonShopItemsResult' => '\\StructType\\SetPricesOnNonShopItemsResult',
            'ArrayOfSetPricesOnNonShopItemsError' => '\\ArrayType\\ArrayOfSetPricesOnNonShopItemsError',
            'SetPricesOnNonShopItemsError' => '\\StructType\\SetPricesOnNonShopItemsError',
            'SetActivateDateOnShopItems' => '\\StructType\\SetActivateDateOnShopItems',
            'SetActivateDateOnShopItemsRequest' => '\\StructType\\SetActivateDateOnShopItemsRequest',
            'ArrayOfSetActivateDateShopItem' => '\\ArrayType\\ArrayOfSetActivateDateShopItem',
            'SetActivateDateShopItem' => '\\StructType\\SetActivateDateShopItem',
            'SetActivateDateOnShopItemsResponse' => '\\StructType\\SetActivateDateOnShopItemsResponse',
            'SetActivateDateOnShopItemsResult' => '\\StructType\\SetActivateDateOnShopItemsResult',
            'ArrayOfSetActivateDateOnShopItemsError' => '\\ArrayType\\ArrayOfSetActivateDateOnShopItemsError',
            'SetActivateDateOnShopItemsError' => '\\StructType\\SetActivateDateOnShopItemsError',
            'SetQuantityOnShopItems' => '\\StructType\\SetQuantityOnShopItems',
            'SetQuantityOnShopItemsRequest' => '\\StructType\\SetQuantityOnShopItemsRequest',
            'ArrayOfSetQuantityShopItem' => '\\ArrayType\\ArrayOfSetQuantityShopItem',
            'SetQuantityShopItem' => '\\StructType\\SetQuantityShopItem',
            'SetQuantityOnShopItemsResponse' => '\\StructType\\SetQuantityOnShopItemsResponse',
            'SetQuantityOnShopItemsResult' => '\\StructType\\SetQuantityOnShopItemsResult',
            'ArrayOfSetQuantityOnShopItemError' => '\\ArrayType\\ArrayOfSetQuantityOnShopItemError',
            'SetQuantityOnShopItemError' => '\\StructType\\SetQuantityOnShopItemError',
            'LeaveOrderFeedbackToBuyer' => '\\StructType\\LeaveOrderFeedbackToBuyer',
            'LeaveOrderFeedbackToBuyerResponse' => '\\StructType\\LeaveOrderFeedbackToBuyerResponse',
            'GetMemberPaymentOptions' => '\\StructType\\GetMemberPaymentOptions',
            'GetMemberPaymentOptionsResponse' => '\\StructType\\GetMemberPaymentOptionsResponse',
            'GetMemberPaymentOptionsResult' => '\\StructType\\GetMemberPaymentOptionsResult',
            'ArrayOfMemberPaymentOption' => '\\ArrayType\\ArrayOfMemberPaymentOption',
            'MemberPaymentOption' => '\\StructType\\MemberPaymentOption',
        );
    }
}
