<?php

namespace ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Set ServiceType
 * @subpackage Services
 */
class Set extends AbstractSoapClientBase
{
    /**
     * Sets the AuthenticationHeader SoapHeader param
     * @uses AbstractSoapClientBase::setSoapHeader()
     * @param \StructType\AuthenticationHeader $authenticationHeader
     * @param string $nameSpace
     * @param bool $mustUnderstand
     * @param string $actor
     * @return bool
     */
    public function setSoapHeaderAuthenticationHeader(\StructType\AuthenticationHeader $authenticationHeader, $nameSpace = 'http://api.tradera.com', $mustUnderstand = false, $actor = null)
    {
        return $this->setSoapHeader($nameSpace, 'AuthenticationHeader', $authenticationHeader, $mustUnderstand, $actor);
    }
    /**
     * Sets the AuthorizationHeader SoapHeader param
     * @uses AbstractSoapClientBase::setSoapHeader()
     * @param \StructType\AuthorizationHeader $authorizationHeader
     * @param string $nameSpace
     * @param bool $mustUnderstand
     * @param string $actor
     * @return bool
     */
    public function setSoapHeaderAuthorizationHeader(\StructType\AuthorizationHeader $authorizationHeader, $nameSpace = 'http://api.tradera.com', $mustUnderstand = false, $actor = null)
    {
        return $this->setSoapHeader($nameSpace, 'AuthorizationHeader', $authorizationHeader, $mustUnderstand, $actor);
    }
    /**
     * Sets the ConfigurationHeader SoapHeader param
     * @uses AbstractSoapClientBase::setSoapHeader()
     * @param \StructType\ConfigurationHeader $configurationHeader
     * @param string $nameSpace
     * @param bool $mustUnderstand
     * @param string $actor
     * @return bool
     */
    public function setSoapHeaderConfigurationHeader(\StructType\ConfigurationHeader $configurationHeader, $nameSpace = 'http://api.tradera.com', $mustUnderstand = false, $actor = null)
    {
        return $this->setSoapHeader($nameSpace, 'ConfigurationHeader', $configurationHeader, $mustUnderstand, $actor);
    }
    /**
     * Method to call the operation originally named SetShopSettings
     * Meta information extracted from the WSDL
     * - SOAPHeaderNames: AuthenticationHeader, AuthorizationHeader, ConfigurationHeader
     * - SOAPHeaderNamespaces: http://api.tradera.com, http://api.tradera.com, http://api.tradera.com
     * - SOAPHeaderTypes: \StructType\AuthenticationHeader, \StructType\AuthorizationHeader, \StructType\ConfigurationHeader
     * - SOAPHeaders: required, required, required
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\SetShopSettings $parameters
     * @return \StructType\SetShopSettingsResponse|bool
     */
    public function SetShopSettings(\StructType\SetShopSettings $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->SetShopSettings($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named SetPriceOnShopItems
     * Meta information extracted from the WSDL
     * - SOAPHeaderNames: AuthenticationHeader, AuthorizationHeader, ConfigurationHeader
     * - SOAPHeaderNamespaces: http://api.tradera.com, http://api.tradera.com, http://api.tradera.com
     * - SOAPHeaderTypes: \StructType\AuthenticationHeader, \StructType\AuthorizationHeader, \StructType\ConfigurationHeader
     * - SOAPHeaders: required, required, required
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\SetPriceOnShopItems $parameters
     * @return \StructType\SetPriceOnShopItemsResponse|bool
     */
    public function SetPriceOnShopItems(\StructType\SetPriceOnShopItems $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->SetPriceOnShopItems($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named SetPricesOnNonShopItems
     * Meta information extracted from the WSDL
     * - SOAPHeaderNames: AuthenticationHeader, AuthorizationHeader, ConfigurationHeader
     * - SOAPHeaderNamespaces: http://api.tradera.com, http://api.tradera.com, http://api.tradera.com
     * - SOAPHeaderTypes: \StructType\AuthenticationHeader, \StructType\AuthorizationHeader, \StructType\ConfigurationHeader
     * - SOAPHeaders: required, required, required
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\SetPricesOnNonShopItems $parameters
     * @return \StructType\SetPricesOnNonShopItemsResponse|bool
     */
    public function SetPricesOnNonShopItems(\StructType\SetPricesOnNonShopItems $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->SetPricesOnNonShopItems($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named SetActivateDateOnShopItems
     * Meta information extracted from the WSDL
     * - SOAPHeaderNames: AuthenticationHeader, AuthorizationHeader, ConfigurationHeader
     * - SOAPHeaderNamespaces: http://api.tradera.com, http://api.tradera.com, http://api.tradera.com
     * - SOAPHeaderTypes: \StructType\AuthenticationHeader, \StructType\AuthorizationHeader, \StructType\ConfigurationHeader
     * - SOAPHeaders: required, required, required
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\SetActivateDateOnShopItems $parameters
     * @return \StructType\SetActivateDateOnShopItemsResponse|bool
     */
    public function SetActivateDateOnShopItems(\StructType\SetActivateDateOnShopItems $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->SetActivateDateOnShopItems($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named SetQuantityOnShopItems
     * Meta information extracted from the WSDL
     * - SOAPHeaderNames: AuthenticationHeader, AuthorizationHeader, ConfigurationHeader
     * - SOAPHeaderNamespaces: http://api.tradera.com, http://api.tradera.com, http://api.tradera.com
     * - SOAPHeaderTypes: \StructType\AuthenticationHeader, \StructType\AuthorizationHeader, \StructType\ConfigurationHeader
     * - SOAPHeaders: required, required, required
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\SetQuantityOnShopItems $parameters
     * @return \StructType\SetQuantityOnShopItemsResponse|bool
     */
    public function SetQuantityOnShopItems(\StructType\SetQuantityOnShopItems $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->SetQuantityOnShopItems($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \StructType\SetActivateDateOnShopItemsResponse|\StructType\SetPriceOnShopItemsResponse|\StructType\SetPricesOnNonShopItemsResponse|\StructType\SetQuantityOnShopItemsResponse|\StructType\SetShopSettingsResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
}
