<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ItemAttributeValues StructType
 * @subpackage Structs
 */
class ItemAttributeValues extends AbstractStructBase
{
    /**
     * The Terms
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfTermValues
     */
    public $Terms;
    /**
     * The Numbers
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfNumberValues
     */
    public $Numbers;
    /**
     * Constructor method for ItemAttributeValues
     * @uses ItemAttributeValues::setTerms()
     * @uses ItemAttributeValues::setNumbers()
     * @param \ArrayType\ArrayOfTermValues $terms
     * @param \ArrayType\ArrayOfNumberValues $numbers
     */
    public function __construct(\ArrayType\ArrayOfTermValues $terms = null, \ArrayType\ArrayOfNumberValues $numbers = null)
    {
        $this
            ->setTerms($terms)
            ->setNumbers($numbers);
    }
    /**
     * Get Terms value
     * @return \ArrayType\ArrayOfTermValues|null
     */
    public function getTerms()
    {
        return $this->Terms;
    }
    /**
     * Set Terms value
     * @param \ArrayType\ArrayOfTermValues $terms
     * @return \StructType\ItemAttributeValues
     */
    public function setTerms(\ArrayType\ArrayOfTermValues $terms = null)
    {
        $this->Terms = $terms;
        return $this;
    }
    /**
     * Get Numbers value
     * @return \ArrayType\ArrayOfNumberValues|null
     */
    public function getNumbers()
    {
        return $this->Numbers;
    }
    /**
     * Set Numbers value
     * @param \ArrayType\ArrayOfNumberValues $numbers
     * @return \StructType\ItemAttributeValues
     */
    public function setNumbers(\ArrayType\ArrayOfNumberValues $numbers = null)
    {
        $this->Numbers = $numbers;
        return $this;
    }
}
