<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SetPricesNonShopItem StructType
 * @subpackage Structs
 */
class SetPricesNonShopItem extends AbstractStructBase
{
    /**
     * The Id
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $Id;
    /**
     * The OpeningPrice
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $OpeningPrice;
    /**
     * The ReservedPrice
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\ReservedPrice
     */
    public $ReservedPrice;
    /**
     * The BinPrice
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\BinPrice
     */
    public $BinPrice;
    /**
     * Constructor method for SetPricesNonShopItem
     * @uses SetPricesNonShopItem::setId()
     * @uses SetPricesNonShopItem::setOpeningPrice()
     * @uses SetPricesNonShopItem::setReservedPrice()
     * @uses SetPricesNonShopItem::setBinPrice()
     * @param int $id
     * @param int $openingPrice
     * @param \StructType\ReservedPrice $reservedPrice
     * @param \StructType\BinPrice $binPrice
     */
    public function __construct($id = null, $openingPrice = null, \StructType\ReservedPrice $reservedPrice = null, \StructType\BinPrice $binPrice = null)
    {
        $this
            ->setId($id)
            ->setOpeningPrice($openingPrice)
            ->setReservedPrice($reservedPrice)
            ->setBinPrice($binPrice);
    }
    /**
     * Get Id value
     * @return int
     */
    public function getId()
    {
        return $this->Id;
    }
    /**
     * Set Id value
     * @param int $id
     * @return \StructType\SetPricesNonShopItem
     */
    public function setId($id = null)
    {
        // validation for constraint: int
        if (!is_null($id) && !(is_int($id) || ctype_digit($id))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($id, true), gettype($id)), __LINE__);
        }
        $this->Id = $id;
        return $this;
    }
    /**
     * Get OpeningPrice value
     * @return int
     */
    public function getOpeningPrice()
    {
        return $this->OpeningPrice;
    }
    /**
     * Set OpeningPrice value
     * @param int $openingPrice
     * @return \StructType\SetPricesNonShopItem
     */
    public function setOpeningPrice($openingPrice = null)
    {
        // validation for constraint: int
        if (!is_null($openingPrice) && !(is_int($openingPrice) || ctype_digit($openingPrice))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($openingPrice, true), gettype($openingPrice)), __LINE__);
        }
        $this->OpeningPrice = $openingPrice;
        return $this;
    }
    /**
     * Get ReservedPrice value
     * @return \StructType\ReservedPrice|null
     */
    public function getReservedPrice()
    {
        return $this->ReservedPrice;
    }
    /**
     * Set ReservedPrice value
     * @param \StructType\ReservedPrice $reservedPrice
     * @return \StructType\SetPricesNonShopItem
     */
    public function setReservedPrice(\StructType\ReservedPrice $reservedPrice = null)
    {
        $this->ReservedPrice = $reservedPrice;
        return $this;
    }
    /**
     * Get BinPrice value
     * @return \StructType\BinPrice|null
     */
    public function getBinPrice()
    {
        return $this->BinPrice;
    }
    /**
     * Set BinPrice value
     * @param \StructType\BinPrice $binPrice
     * @return \StructType\SetPricesNonShopItem
     */
    public function setBinPrice(\StructType\BinPrice $binPrice = null)
    {
        $this->BinPrice = $binPrice;
        return $this;
    }
}
