<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SetQuantityOnShopItemError StructType
 * @subpackage Structs
 */
class SetQuantityOnShopItemError extends AbstractStructBase
{
    /**
     * The Item
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\SetQuantityShopItem
     */
    public $Item;
    /**
     * The ErrorMessage
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ErrorMessage;
    /**
     * Constructor method for SetQuantityOnShopItemError
     * @uses SetQuantityOnShopItemError::setItem()
     * @uses SetQuantityOnShopItemError::setErrorMessage()
     * @param \StructType\SetQuantityShopItem $item
     * @param string $errorMessage
     */
    public function __construct(\StructType\SetQuantityShopItem $item = null, $errorMessage = null)
    {
        $this
            ->setItem($item)
            ->setErrorMessage($errorMessage);
    }
    /**
     * Get Item value
     * @return \StructType\SetQuantityShopItem|null
     */
    public function getItem()
    {
        return $this->Item;
    }
    /**
     * Set Item value
     * @param \StructType\SetQuantityShopItem $item
     * @return \StructType\SetQuantityOnShopItemError
     */
    public function setItem(\StructType\SetQuantityShopItem $item = null)
    {
        $this->Item = $item;
        return $this;
    }
    /**
     * Get ErrorMessage value
     * @return string|null
     */
    public function getErrorMessage()
    {
        return $this->ErrorMessage;
    }
    /**
     * Set ErrorMessage value
     * @param string $errorMessage
     * @return \StructType\SetQuantityOnShopItemError
     */
    public function setErrorMessage($errorMessage = null)
    {
        // validation for constraint: string
        if (!is_null($errorMessage) && !is_string($errorMessage)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($errorMessage, true), gettype($errorMessage)), __LINE__);
        }
        $this->ErrorMessage = $errorMessage;
        return $this;
    }
}
