<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SetQuantityOnShopItemsResult StructType
 * @subpackage Structs
 */
class SetQuantityOnShopItemsResult extends AbstractStructBase
{
    /**
     * The SuccessfulUpdates
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $SuccessfulUpdates;
    /**
     * The ValidationErrors
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfSetQuantityOnShopItemError
     */
    public $ValidationErrors;
    /**
     * Constructor method for SetQuantityOnShopItemsResult
     * @uses SetQuantityOnShopItemsResult::setSuccessfulUpdates()
     * @uses SetQuantityOnShopItemsResult::setValidationErrors()
     * @param int $successfulUpdates
     * @param \ArrayType\ArrayOfSetQuantityOnShopItemError $validationErrors
     */
    public function __construct($successfulUpdates = null, \ArrayType\ArrayOfSetQuantityOnShopItemError $validationErrors = null)
    {
        $this
            ->setSuccessfulUpdates($successfulUpdates)
            ->setValidationErrors($validationErrors);
    }
    /**
     * Get SuccessfulUpdates value
     * @return int
     */
    public function getSuccessfulUpdates()
    {
        return $this->SuccessfulUpdates;
    }
    /**
     * Set SuccessfulUpdates value
     * @param int $successfulUpdates
     * @return \StructType\SetQuantityOnShopItemsResult
     */
    public function setSuccessfulUpdates($successfulUpdates = null)
    {
        // validation for constraint: int
        if (!is_null($successfulUpdates) && !(is_int($successfulUpdates) || ctype_digit($successfulUpdates))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($successfulUpdates, true), gettype($successfulUpdates)), __LINE__);
        }
        $this->SuccessfulUpdates = $successfulUpdates;
        return $this;
    }
    /**
     * Get ValidationErrors value
     * @return \ArrayType\ArrayOfSetQuantityOnShopItemError|null
     */
    public function getValidationErrors()
    {
        return $this->ValidationErrors;
    }
    /**
     * Set ValidationErrors value
     * @param \ArrayType\ArrayOfSetQuantityOnShopItemError $validationErrors
     * @return \StructType\SetQuantityOnShopItemsResult
     */
    public function setValidationErrors(\ArrayType\ArrayOfSetQuantityOnShopItemError $validationErrors = null)
    {
        $this->ValidationErrors = $validationErrors;
        return $this;
    }
}
