<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TermValues StructType
 * @subpackage Structs
 */
class TermValues extends AbstractStructBase
{
    /**
     * The Id
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $Id;
    /**
     * The Values
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfString
     */
    public $Values;
    /**
     * Constructor method for TermValues
     * @uses TermValues::setId()
     * @uses TermValues::setValues()
     * @param int $id
     * @param \ArrayType\ArrayOfString $values
     */
    public function __construct($id = null, \ArrayType\ArrayOfString $values = null)
    {
        $this
            ->setId($id)
            ->setValues($values);
    }
    /**
     * Get Id value
     * @return int
     */
    public function getId()
    {
        return $this->Id;
    }
    /**
     * Set Id value
     * @param int $id
     * @return \StructType\TermValues
     */
    public function setId($id = null)
    {
        // validation for constraint: int
        if (!is_null($id) && !(is_int($id) || ctype_digit($id))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($id, true), gettype($id)), __LINE__);
        }
        $this->Id = $id;
        return $this;
    }
    /**
     * Get Values value
     * @return \ArrayType\ArrayOfString|null
     */
    public function getValues()
    {
        return $this->Values;
    }
    /**
     * Set Values value
     * @param \ArrayType\ArrayOfString $values
     * @return \StructType\TermValues
     */
    public function setValues(\ArrayType\ArrayOfString $values = null)
    {
        $this->Values = $values;
        return $this;
    }
}
