<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ValidateCampaignCodeResult StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ValidateCampaignCodeResult
 * @subpackage Structs
 */
class ValidateCampaignCodeResult extends AbstractStructBase
{
    /**
     * The IsValid
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $IsValid;
    /**
     * The IsInvalidBecauseDoesNotExist
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $IsInvalidBecauseDoesNotExist;
    /**
     * The IsInvalidBecauseHasNotStarted
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $IsInvalidBecauseHasNotStarted;
    /**
     * The IsInvalidBecauseHasEnded
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $IsInvalidBecauseHasEnded;
    /**
     * The IsInvalidBecauseCategoryIsNotAllowed
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $IsInvalidBecauseCategoryIsNotAllowed;
    /**
     * The IsInvalidBecauseAlreadyUsed
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $IsInvalidBecauseAlreadyUsed;
    /**
     * The IsInvalidBecauseUserIsNotAllowed
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $IsInvalidBecauseUserIsNotAllowed;
    /**
     * The DiscountFactor
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var float
     */
    public $DiscountFactor;
    /**
     * The ProvisionFactor
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var float
     */
    public $ProvisionFactor;
    /**
     * The MaxFeeCap
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var float
     */
    public $MaxFeeCap;
    /**
     * The IsCustomLengthFeeFree
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $IsCustomLengthFeeFree;
    /**
     * The IsUnsoldFeeFree
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $IsUnsoldFeeFree;
    /**
     * The Description
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Description;
    /**
     * Constructor method for ValidateCampaignCodeResult
     * @uses ValidateCampaignCodeResult::setIsValid()
     * @uses ValidateCampaignCodeResult::setIsInvalidBecauseDoesNotExist()
     * @uses ValidateCampaignCodeResult::setIsInvalidBecauseHasNotStarted()
     * @uses ValidateCampaignCodeResult::setIsInvalidBecauseHasEnded()
     * @uses ValidateCampaignCodeResult::setIsInvalidBecauseCategoryIsNotAllowed()
     * @uses ValidateCampaignCodeResult::setIsInvalidBecauseAlreadyUsed()
     * @uses ValidateCampaignCodeResult::setIsInvalidBecauseUserIsNotAllowed()
     * @uses ValidateCampaignCodeResult::setDiscountFactor()
     * @uses ValidateCampaignCodeResult::setProvisionFactor()
     * @uses ValidateCampaignCodeResult::setMaxFeeCap()
     * @uses ValidateCampaignCodeResult::setIsCustomLengthFeeFree()
     * @uses ValidateCampaignCodeResult::setIsUnsoldFeeFree()
     * @uses ValidateCampaignCodeResult::setDescription()
     * @param bool $isValid
     * @param bool $isInvalidBecauseDoesNotExist
     * @param bool $isInvalidBecauseHasNotStarted
     * @param bool $isInvalidBecauseHasEnded
     * @param bool $isInvalidBecauseCategoryIsNotAllowed
     * @param bool $isInvalidBecauseAlreadyUsed
     * @param bool $isInvalidBecauseUserIsNotAllowed
     * @param float $discountFactor
     * @param float $provisionFactor
     * @param float $maxFeeCap
     * @param bool $isCustomLengthFeeFree
     * @param bool $isUnsoldFeeFree
     * @param string $description
     */
    public function __construct($isValid = null, $isInvalidBecauseDoesNotExist = null, $isInvalidBecauseHasNotStarted = null, $isInvalidBecauseHasEnded = null, $isInvalidBecauseCategoryIsNotAllowed = null, $isInvalidBecauseAlreadyUsed = null, $isInvalidBecauseUserIsNotAllowed = null, $discountFactor = null, $provisionFactor = null, $maxFeeCap = null, $isCustomLengthFeeFree = null, $isUnsoldFeeFree = null, $description = null)
    {
        $this
            ->setIsValid($isValid)
            ->setIsInvalidBecauseDoesNotExist($isInvalidBecauseDoesNotExist)
            ->setIsInvalidBecauseHasNotStarted($isInvalidBecauseHasNotStarted)
            ->setIsInvalidBecauseHasEnded($isInvalidBecauseHasEnded)
            ->setIsInvalidBecauseCategoryIsNotAllowed($isInvalidBecauseCategoryIsNotAllowed)
            ->setIsInvalidBecauseAlreadyUsed($isInvalidBecauseAlreadyUsed)
            ->setIsInvalidBecauseUserIsNotAllowed($isInvalidBecauseUserIsNotAllowed)
            ->setDiscountFactor($discountFactor)
            ->setProvisionFactor($provisionFactor)
            ->setMaxFeeCap($maxFeeCap)
            ->setIsCustomLengthFeeFree($isCustomLengthFeeFree)
            ->setIsUnsoldFeeFree($isUnsoldFeeFree)
            ->setDescription($description);
    }
    /**
     * Get IsValid value
     * @return bool
     */
    public function getIsValid()
    {
        return $this->IsValid;
    }
    /**
     * Set IsValid value
     * @param bool $isValid
     * @return \StructType\ValidateCampaignCodeResult
     */
    public function setIsValid($isValid = null)
    {
        // validation for constraint: boolean
        if (!is_null($isValid) && !is_bool($isValid)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($isValid, true), gettype($isValid)), __LINE__);
        }
        $this->IsValid = $isValid;
        return $this;
    }
    /**
     * Get IsInvalidBecauseDoesNotExist value
     * @return bool
     */
    public function getIsInvalidBecauseDoesNotExist()
    {
        return $this->IsInvalidBecauseDoesNotExist;
    }
    /**
     * Set IsInvalidBecauseDoesNotExist value
     * @param bool $isInvalidBecauseDoesNotExist
     * @return \StructType\ValidateCampaignCodeResult
     */
    public function setIsInvalidBecauseDoesNotExist($isInvalidBecauseDoesNotExist = null)
    {
        // validation for constraint: boolean
        if (!is_null($isInvalidBecauseDoesNotExist) && !is_bool($isInvalidBecauseDoesNotExist)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($isInvalidBecauseDoesNotExist, true), gettype($isInvalidBecauseDoesNotExist)), __LINE__);
        }
        $this->IsInvalidBecauseDoesNotExist = $isInvalidBecauseDoesNotExist;
        return $this;
    }
    /**
     * Get IsInvalidBecauseHasNotStarted value
     * @return bool
     */
    public function getIsInvalidBecauseHasNotStarted()
    {
        return $this->IsInvalidBecauseHasNotStarted;
    }
    /**
     * Set IsInvalidBecauseHasNotStarted value
     * @param bool $isInvalidBecauseHasNotStarted
     * @return \StructType\ValidateCampaignCodeResult
     */
    public function setIsInvalidBecauseHasNotStarted($isInvalidBecauseHasNotStarted = null)
    {
        // validation for constraint: boolean
        if (!is_null($isInvalidBecauseHasNotStarted) && !is_bool($isInvalidBecauseHasNotStarted)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($isInvalidBecauseHasNotStarted, true), gettype($isInvalidBecauseHasNotStarted)), __LINE__);
        }
        $this->IsInvalidBecauseHasNotStarted = $isInvalidBecauseHasNotStarted;
        return $this;
    }
    /**
     * Get IsInvalidBecauseHasEnded value
     * @return bool
     */
    public function getIsInvalidBecauseHasEnded()
    {
        return $this->IsInvalidBecauseHasEnded;
    }
    /**
     * Set IsInvalidBecauseHasEnded value
     * @param bool $isInvalidBecauseHasEnded
     * @return \StructType\ValidateCampaignCodeResult
     */
    public function setIsInvalidBecauseHasEnded($isInvalidBecauseHasEnded = null)
    {
        // validation for constraint: boolean
        if (!is_null($isInvalidBecauseHasEnded) && !is_bool($isInvalidBecauseHasEnded)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($isInvalidBecauseHasEnded, true), gettype($isInvalidBecauseHasEnded)), __LINE__);
        }
        $this->IsInvalidBecauseHasEnded = $isInvalidBecauseHasEnded;
        return $this;
    }
    /**
     * Get IsInvalidBecauseCategoryIsNotAllowed value
     * @return bool
     */
    public function getIsInvalidBecauseCategoryIsNotAllowed()
    {
        return $this->IsInvalidBecauseCategoryIsNotAllowed;
    }
    /**
     * Set IsInvalidBecauseCategoryIsNotAllowed value
     * @param bool $isInvalidBecauseCategoryIsNotAllowed
     * @return \StructType\ValidateCampaignCodeResult
     */
    public function setIsInvalidBecauseCategoryIsNotAllowed($isInvalidBecauseCategoryIsNotAllowed = null)
    {
        // validation for constraint: boolean
        if (!is_null($isInvalidBecauseCategoryIsNotAllowed) && !is_bool($isInvalidBecauseCategoryIsNotAllowed)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($isInvalidBecauseCategoryIsNotAllowed, true), gettype($isInvalidBecauseCategoryIsNotAllowed)), __LINE__);
        }
        $this->IsInvalidBecauseCategoryIsNotAllowed = $isInvalidBecauseCategoryIsNotAllowed;
        return $this;
    }
    /**
     * Get IsInvalidBecauseAlreadyUsed value
     * @return bool
     */
    public function getIsInvalidBecauseAlreadyUsed()
    {
        return $this->IsInvalidBecauseAlreadyUsed;
    }
    /**
     * Set IsInvalidBecauseAlreadyUsed value
     * @param bool $isInvalidBecauseAlreadyUsed
     * @return \StructType\ValidateCampaignCodeResult
     */
    public function setIsInvalidBecauseAlreadyUsed($isInvalidBecauseAlreadyUsed = null)
    {
        // validation for constraint: boolean
        if (!is_null($isInvalidBecauseAlreadyUsed) && !is_bool($isInvalidBecauseAlreadyUsed)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($isInvalidBecauseAlreadyUsed, true), gettype($isInvalidBecauseAlreadyUsed)), __LINE__);
        }
        $this->IsInvalidBecauseAlreadyUsed = $isInvalidBecauseAlreadyUsed;
        return $this;
    }
    /**
     * Get IsInvalidBecauseUserIsNotAllowed value
     * @return bool
     */
    public function getIsInvalidBecauseUserIsNotAllowed()
    {
        return $this->IsInvalidBecauseUserIsNotAllowed;
    }
    /**
     * Set IsInvalidBecauseUserIsNotAllowed value
     * @param bool $isInvalidBecauseUserIsNotAllowed
     * @return \StructType\ValidateCampaignCodeResult
     */
    public function setIsInvalidBecauseUserIsNotAllowed($isInvalidBecauseUserIsNotAllowed = null)
    {
        // validation for constraint: boolean
        if (!is_null($isInvalidBecauseUserIsNotAllowed) && !is_bool($isInvalidBecauseUserIsNotAllowed)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($isInvalidBecauseUserIsNotAllowed, true), gettype($isInvalidBecauseUserIsNotAllowed)), __LINE__);
        }
        $this->IsInvalidBecauseUserIsNotAllowed = $isInvalidBecauseUserIsNotAllowed;
        return $this;
    }
    /**
     * Get DiscountFactor value
     * @return float
     */
    public function getDiscountFactor()
    {
        return $this->DiscountFactor;
    }
    /**
     * Set DiscountFactor value
     * @param float $discountFactor
     * @return \StructType\ValidateCampaignCodeResult
     */
    public function setDiscountFactor($discountFactor = null)
    {
        // validation for constraint: float
        if (!is_null($discountFactor) && !(is_float($discountFactor) || is_numeric($discountFactor))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($discountFactor, true), gettype($discountFactor)), __LINE__);
        }
        $this->DiscountFactor = $discountFactor;
        return $this;
    }
    /**
     * Get ProvisionFactor value
     * @return float
     */
    public function getProvisionFactor()
    {
        return $this->ProvisionFactor;
    }
    /**
     * Set ProvisionFactor value
     * @param float $provisionFactor
     * @return \StructType\ValidateCampaignCodeResult
     */
    public function setProvisionFactor($provisionFactor = null)
    {
        // validation for constraint: float
        if (!is_null($provisionFactor) && !(is_float($provisionFactor) || is_numeric($provisionFactor))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($provisionFactor, true), gettype($provisionFactor)), __LINE__);
        }
        $this->ProvisionFactor = $provisionFactor;
        return $this;
    }
    /**
     * Get MaxFeeCap value
     * @return float
     */
    public function getMaxFeeCap()
    {
        return $this->MaxFeeCap;
    }
    /**
     * Set MaxFeeCap value
     * @param float $maxFeeCap
     * @return \StructType\ValidateCampaignCodeResult
     */
    public function setMaxFeeCap($maxFeeCap = null)
    {
        // validation for constraint: float
        if (!is_null($maxFeeCap) && !(is_float($maxFeeCap) || is_numeric($maxFeeCap))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($maxFeeCap, true), gettype($maxFeeCap)), __LINE__);
        }
        $this->MaxFeeCap = $maxFeeCap;
        return $this;
    }
    /**
     * Get IsCustomLengthFeeFree value
     * @return bool
     */
    public function getIsCustomLengthFeeFree()
    {
        return $this->IsCustomLengthFeeFree;
    }
    /**
     * Set IsCustomLengthFeeFree value
     * @param bool $isCustomLengthFeeFree
     * @return \StructType\ValidateCampaignCodeResult
     */
    public function setIsCustomLengthFeeFree($isCustomLengthFeeFree = null)
    {
        // validation for constraint: boolean
        if (!is_null($isCustomLengthFeeFree) && !is_bool($isCustomLengthFeeFree)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($isCustomLengthFeeFree, true), gettype($isCustomLengthFeeFree)), __LINE__);
        }
        $this->IsCustomLengthFeeFree = $isCustomLengthFeeFree;
        return $this;
    }
    /**
     * Get IsUnsoldFeeFree value
     * @return bool
     */
    public function getIsUnsoldFeeFree()
    {
        return $this->IsUnsoldFeeFree;
    }
    /**
     * Set IsUnsoldFeeFree value
     * @param bool $isUnsoldFeeFree
     * @return \StructType\ValidateCampaignCodeResult
     */
    public function setIsUnsoldFeeFree($isUnsoldFeeFree = null)
    {
        // validation for constraint: boolean
        if (!is_null($isUnsoldFeeFree) && !is_bool($isUnsoldFeeFree)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($isUnsoldFeeFree, true), gettype($isUnsoldFeeFree)), __LINE__);
        }
        $this->IsUnsoldFeeFree = $isUnsoldFeeFree;
        return $this;
    }
    /**
     * Get Description value
     * @return string|null
     */
    public function getDescription()
    {
        return $this->Description;
    }
    /**
     * Set Description value
     * @param string $description
     * @return \StructType\ValidateCampaignCodeResult
     */
    public function setDescription($description = null)
    {
        // validation for constraint: string
        if (!is_null($description) && !is_string($description)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($description, true), gettype($description)), __LINE__);
        }
        $this->Description = $description;
        return $this;
    }
}
